Index: /contrib/z-push/zpushdtd.php
===================================================================
--- /contrib/z-push/zpushdtd.php	(revision 4898)
+++ /contrib/z-push/zpushdtd.php	(revision 4898)
@@ -0,0 +1,407 @@
+<?php
+/***********************************************
+* File      :   zpushdtd.php
+* Project   :   Z-Push
+* Descr     :   dtd definition file
+*
+* Created   :   01.10.2007
+*
+*  Zarafa Deutschland GmbH, www.zarafaserver.de
+* This file is distributed under GPL v2.
+* Consult LICENSE file for details
+************************************************/
+$zpushdtd = array(
+                "codes" => array (
+                    0 => array (
+                        0x05 => "Synchronize",
+                        0x06 => "Replies",
+                        0x07 => "Add",
+                        0x08 => "Modify",
+                        0x09 => "Remove",
+                        0x0a => "Fetch",
+                        0x0b => "SyncKey",
+                        0x0c => "ClientEntryId",
+                        0x0d => "ServerEntryId",
+                        0x0e => "Status",
+                        0x0f => "Folder",
+                        0x10 => "FolderType",
+                        0x11 => "Version",
+                        0x12 => "FolderId",
+                        0x13 => "GetChanges",
+                        0x14 => "MoreAvailable",
+                        0x15 => "MaxItems",
+                        0x16 => "Perform",
+                        0x17 => "Options",
+                        0x18 => "FilterType",
+                        0x19 => "Truncation",
+                        0x1a => "RtfTruncation",
+                        0x1b => "Conflict",
+                        0x1c => "Folders",
+                        0x1d => "Data",
+                        0x1e => "DeletesAsMoves",
+                        0x1f => "NotifyGUID",
+                        0x20 => "Supported",
+                        0x21 => "SoftDelete",
+                        0x22 => "MIMESupport",
+                        0x23 => "MIMETruncation",
+                    ), 1 => array (
+                        0x05 => "Anniversary",
+                        0x06 => "AssistantName",
+                        0x07 => "AssistnamePhoneNumber",
+                        0x08 => "Birthday",
+                        0x09 => "Body",
+                        0x0a => "BodySize",
+                        0x0b => "BodyTruncated",
+                        0x0c => "Business2PhoneNumber",
+                        0x0d => "BusinessCity",
+                        0x0e => "BusinessCountry",
+                        0x0f => "BusinessPostalCode",
+                        0x10 => "BusinessState",
+                        0x11 => "BusinessStreet",
+                        0x12 => "BusinessFaxNumber",
+                        0x13 => "BusinessPhoneNumber",
+                        0x14 => "CarPhoneNumber",
+                        0x15 => "Categories",
+                        0x16 => "Category",
+                        0x17 => "Children",
+                        0x18 => "Child",
+                        0x19 => "CompanyName",
+                        0x1a => "Department",
+                        0x1b => "Email1Address",
+                        0x1c => "Email2Address",
+                        0x1d => "Email3Address",
+                        0x1e => "FileAs",
+                        0x1f => "FirstName",
+                        0x20 => "Home2PhoneNumber",
+                        0x21 => "HomeCity",
+                        0x22 => "HomeCountry",
+                        0x23 => "HomePostalCode",
+                        0x24 => "HomeState",
+                        0x25 => "HomeStreet",
+                        0x26 => "HomeFaxNumber",
+                        0x27 => "HomePhoneNumber",
+                        0x28 => "JobTitle",
+                        0x29 => "LastName",
+                        0x2a => "MiddleName",
+                        0x2b => "MobilePhoneNumber",
+                        0x2c => "OfficeLocation",
+                        0x2d => "OtherCity",
+                        0x2e => "OtherCountry",
+                        0x2f => "OtherPostalCode",
+                        0x30 => "OtherState",
+                        0x31 => "OtherStreet",
+                        0x32 => "PagerNumber",
+                        0x33 => "RadioPhoneNumber",
+                        0x34 => "Spouse",
+                        0x35 => "Suffix",
+                        0x36 => "Title",
+                        0x37 => "WebPage",
+                        0x38 => "YomiCompanyName",
+                        0x39 => "YomiFirstName",
+                        0x3a => "YomiLastName",
+                        0x3b => "Rtf",
+                        0x3c => "Picture",
+                    ), 2 => array (
+                        0x05 => "Attachment",
+                        0x06 => "Attachments",
+                        0x07 => "AttName",
+                        0x08 => "AttSize",
+                        0x09 => "AttOid",
+                        0x0a => "AttMethod",
+                        0x0b => "AttRemoved",
+                        0x0c => "Body",
+                        0x0d => "BodySize",
+                        0x0e => "BodyTruncated",
+                        0x0f => "DateReceived",
+                        0x10 => "DisplayName",
+                        0x11 => "DisplayTo",
+                        0x12 => "Importance",
+                        0x13 => "MessageClass",
+                        0x14 => "Subject",
+                        0x15 => "Read",
+                        0x16 => "To",
+                        0x17 => "Cc",
+                        0x18 => "From",
+                        0x19 => "Reply-To",
+                        0x1a => "AllDayEvent",
+                        0x1b => "Categories",
+                        0x1c => "Category",
+                        0x1d => "DtStamp",
+                        0x1e => "EndTime",
+                        0x1f => "InstanceType",
+                        0x20 => "BusyStatus",
+                        0x21 => "Location",
+                        0x22 => "MeetingRequest",
+                        0x23 => "Organizer",
+                        0x24 => "RecurrenceId",
+                        0x25 => "Reminder",
+                        0x26 => "ResponseRequested",
+                        0x27 => "Recurrences",
+                        0x28 => "Recurrence",
+                        0x29 => "Type",
+                        0x2a => "Until",
+                        0x2b => "Occurrences",
+                        0x2c => "Interval",
+                        0x2d => "DayOfWeek",
+                        0x2e => "DayOfMonth",
+                        0x2f => "WeekOfMonth",
+                        0x30 => "MonthOfYear",
+                        0x31 => "StartTime",
+                        0x32 => "Sensitivity",
+                        0x33 => "TimeZone",
+                        0x34 => "GlobalObjId",
+                        0x35 => "ThreadTopic",
+                        0x36 => "MIMEData",
+                        0x37 => "MIMETruncated",
+                        0x38 => "MIMESize",
+                        0x39 => "InternetCPID",
+                    ), 3 => array (
+                        0x05 => "Notify",
+                        0x06 => "Notification",
+                        0x07 => "Version",
+                        0x08 => "Lifetime",
+                        0x09 => "DeviceInfo",
+                        0x0a => "Enable",
+                        0x0b => "Folder",
+                        0x0c => "ServerEntryId",
+                        0x0d => "DeviceAddress",
+                        0x0e => "ValidCarrierProfiles",
+                        0x0f => "CarrierProfile",
+                        0x10 => "Status",
+                        0x11 => "Replies",
+//                        0x05 => "Version='1.1'",
+                        0x12 => "Devices",
+                        0x13 => "Device",
+                        0x14 => "Id",
+                        0x15 => "Expiry",
+                        0x16 => "NotifyGUID",
+                    ), 4 => array (
+                        0x05 => "Timezone",
+                        0x06 => "AllDayEvent",
+                        0x07 => "Attendees",
+                        0x08 => "Attendee",
+                        0x09 => "Email",
+                        0x0a => "Name",
+                        0x0b => "Body",
+                        0x0c => "BodyTruncated",
+                        0x0d => "BusyStatus",
+                        0x0e => "Categories",
+                        0x0f => "Category",
+                        0x10 => "Rtf",
+                        0x11 => "DtStamp",
+                        0x12 => "EndTime",
+                        0x13 => "Exception",
+                        0x14 => "Exceptions",
+                        0x15 => "Deleted",
+                        0x16 => "ExceptionStartTime",
+                        0x17 => "Location",
+                        0x18 => "MeetingStatus",
+                        0x19 => "OrganizerEmail",
+                        0x1a => "OrganizerName",
+                        0x1b => "Recurrence",
+                        0x1c => "Type",
+                        0x1d => "Until",
+                        0x1e => "Occurrences",
+                        0x1f => "Interval",
+                        0x20 => "DayOfWeek",
+                        0x21 => "DayOfMonth",
+                        0x22 => "WeekOfMonth",
+                        0x23 => "MonthOfYear",
+                        0x24 => "Reminder",
+                        0x25 => "Sensitivity",
+                        0x26 => "Subject",
+                        0x27 => "StartTime",
+                        0x28 => "UID",
+                    ), 5 => array (
+                        0x05 => "Moves",
+                        0x06 => "Move",
+                        0x07 => "SrcMsgId",
+                        0x08 => "SrcFldId",
+                        0x09 => "DstFldId",
+                        0x0a => "Response",
+                        0x0b => "Status",
+                        0x0c => "DstMsgId",
+                    ), 6 => array (
+                        0x05 => "GetItemEstimate",
+                        0x06 => "Version",
+                        0x07 => "Folders",
+                        0x08 => "Folder",
+                        0x09 => "FolderType",
+                        0x0a => "FolderId",
+                        0x0b => "DateTime",
+                        0x0c => "Estimate",
+                        0x0d => "Response",
+                        0x0e => "Status",
+                    ), 7 => array (
+                        0x05 => "Folders",
+                        0x06 => "Folder",
+                        0x07 => "DisplayName",
+                        0x08 => "ServerEntryId",
+                        0x09 => "ParentId",
+                        0x0a => "Type",
+                        0x0b => "Response",
+                        0x0c => "Status",
+                        0x0d => "ContentClass",
+                        0x0e => "Changes",
+                        0x0f => "Add",
+                        0x10 => "Remove",
+                        0x11 => "Update",
+                        0x12 => "SyncKey",
+                        0x13 => "FolderCreate",
+                        0x14 => "FolderDelete",
+                        0x15 => "FolderUpdate",
+                        0x16 => "FolderSync",
+                        0x17 => "Count",
+                        0x18 => "Version",
+                    ), 8 => array (
+                        0x05 => "CalendarId",
+                        0x06 => "FolderId",
+                        0x07 => "MeetingResponse",
+                        0x08 => "RequestId",
+                        0x09 => "Request",
+                        0x0a => "Result",
+                        0x0b => "Status",
+                        0x0c => "UserResponse",
+                        0x0d => "Version",
+                    ), 9 => array (
+                        0x05 => "Body",
+                        0x06 => "BodySize",
+                        0x07 => "BodyTruncated",
+                        0x08 => "Categories",
+                        0x09 => "Category",
+                        0x0a => "Complete",
+                        0x0b => "DateCompleted",
+                        0x0c => "DueDate",
+                        0x0d => "UtcDueDate",
+                        0x0e => "Importance",
+                        0x0f => "Recurrence",
+                        0x10 => "Type",
+                        0x11 => "Start",
+                        0x12 => "Until",
+                        0x13 => "Occurrences",
+                        0x14 => "Interval",
+                        0x16 => "DayOfWeek",
+                        0x15 => "DayOfMonth",
+                        0x17 => "WeekOfMonth",
+                        0x18 => "MonthOfYear",
+                        0x19 => "Regenerate",
+                        0x1a => "DeadOccur",
+                        0x1b => "ReminderSet",
+                        0x1c => "ReminderTime",
+                        0x1d => "Sensitivity",
+                        0x1e => "StartDate",
+                        0x1f => "UtcStartDate",
+                        0x20 => "Subject",
+                        0x21 => "Rtf",
+                    ), 0xa => array (
+                        0x05 => "ResolveRecipients",
+                        0x06 => "Response",
+                        0x07 => "Status",
+                        0x08 => "Type",
+                        0x09 => "Recipient",
+                        0x0a => "DisplayName",
+                        0x0b => "EmailAddress",
+                        0x0c => "Certificates",
+                        0x0d => "Certificate",
+                        0x0e => "MiniCertificate",
+                        0x0f => "Options",
+                        0x10 => "To",
+                        0x11 => "CertificateRetrieval",
+                        0x12 => "RecipientCount",
+                        0x13 => "MaxCertificates",
+                        0x14 => "MaxAmbiguousRecipients",
+                        0x15 => "CertificateCount",
+                    ), 0xb => array (
+                        0x05 => "ValidateCert",
+                        0x06 => "Certificates",
+                        0x07 => "Certificate",
+                        0x08 => "CertificateChain",
+                        0x09 => "CheckCRL",
+                        0x0a => "Status",
+                    ), 0xc => array (
+                        0x05 => "CustomerId",
+                        0x06 => "GovernmentId",
+                        0x07 => "IMAddress",
+                        0x08 => "IMAddress2",
+                        0x09 => "IMAddress3",
+                        0x0a => "ManagerName",
+                        0x0b => "CompanyMainPhone",
+                        0x0c => "AccountName",
+                        0x0d => "NickName",
+                        0x0e => "MMS",
+                    ), 0xd => array (
+                        0x05 => "Ping",
+                        0x07 => "Status",
+                        0x08 => "LifeTime",
+                        0x09 => "Folders",
+                        0x0a => "Folder",
+                        0x0b => "ServerEntryId",
+                        0x0c => "FolderType",
+                    ), 0xe => array (
+                        0x05 => "Provision",
+                        0x06 => "Policies",
+                        0x07 => "Policy",
+                        0x08 => "PolicyType",
+                        0x09 => "PolicyKey",
+                        0x0A => "Data",
+                        0x0B => "Status",
+                        0x0C => "RemoteWipe",
+                        0x0D => "EASProvisionDoc",
+                        ),
+                    0xf => array(
+                        0x05 => "Search",
+                        0x07 => "Store",
+                        0x08 => "Name",
+                        0x09 => "Query",
+                        0x0A => "Options",
+                        0x0B => "Range",
+                        0x0C => "Status",
+                        0x0D => "Response",
+                        0x0E => "Result",
+                        0x0F => "Properties",
+                        0x10 => "Total",
+                        0x11 => "EqualTo",
+                        0x12 => "Value",
+                        0x13 => "And",
+                        0x14 => "Or",
+                        0x15 => "FreeText",
+                        0x17 => "DeepTraversal",
+                        0x18 => "LongId",
+                        0x19 => "RebuildResults",
+                        0x1A => "LessThan",
+                        0x1B => "GreaterThan",
+                        0x1C => "Schema",
+                        0x1D => "Supported",
+                    ), 0x10 => array(
+                        0x05 => "DisplayName",
+                        0x06 => "Phone",
+                        0x07 => "Office",
+                        0x08 => "Title",
+                        0x09 => "Company",
+                        0x0A => "Alias",
+                        0x0B => "FirstName",
+                        0x0C => "LastName",
+                        0x0D => "HomePhone",
+                        0x0E => "MobilePhone",
+                        0x0F => "EmailAddress",
+                    )
+              ), "namespaces" => array(
+                  1 => "POOMCONTACTS",
+                  2 => "POOMMAIL",
+                  3 => "AirNotify",
+                  4 => "POOMCAL",
+                  5 => "Move",
+                  6 => "GetItemEstimate",
+                  7 => "FolderHierarchy",
+                  8 => "MeetingResponse",
+                  9 => "POOMTASKS",
+                  0xA => "ResolveRecipients",
+                  0xB => "ValidateCerts",
+                  0xC => "POOMCONTACTS2",
+                  0xD => "Ping",
+                  0xE => "Provision",//
+                  0xF => "Search",//
+                  0x10 => "GAL",
+              )
+          );
+?>
Index: /contrib/z-push/statemachine.php
===================================================================
--- /contrib/z-push/statemachine.php	(revision 4898)
+++ /contrib/z-push/statemachine.php	(revision 4898)
@@ -0,0 +1,116 @@
+<?php
+/***********************************************
+* File      :   statemachine.php
+* Project   :   Z-Push
+* Descr     :   This class handles state requests;
+*               Each differential mechanism can
+*               store its own state information,
+*               which is stored through the
+*               state machine. SyncKey's are
+*               of the  form {UUID}N, in which
+*               UUID is allocated during the
+*               first sync, and N is incremented
+*               for each request to 'getNewSyncKey'.
+*               A sync state is simple an opaque
+*               string value that can differ
+*               for each backend used - normally
+*               a list of items as the backend has
+*               sent them to the PIM. The backend
+*               can then use this backend
+*               information to compute the increments
+*               with current data.
+*
+*               Old sync states are not deleted
+*               until a sync state is requested.
+*               At that moment, the PIM is
+*               apparently requesting an update
+*               since sync key X, so any sync
+*               states before X are already on
+*               the PIM, and can therefore be
+*               removed. This algorithm is
+*               automatically enforced by the
+*               StateMachine class.
+*
+*
+* Created   :   01.10.2007
+*
+* ï¿œ Zarafa Deutschland GmbH, www.zarafaserver.de
+* This file is distributed under GPL v2.
+* Consult LICENSE file for details
+************************************************/
+
+
+class StateMachine {
+    // Gets the sync state for a specified sync key. Requesting a sync key also implies
+    // that previous sync states for this sync key series are no longer needed, and the
+    // state machine will tidy up these files.
+    function getSyncState($synckey) {
+        // No sync state for sync key '0'
+        if($synckey == "0" || $synckey == "s0")
+            return "";
+
+        // Check if synckey is allowed
+        if(!preg_match('/^s{0,1}\{([0-9A-Za-z-]+)\}([0-9]+)$/', $synckey, $matches)) {
+            return false;
+        }
+
+        // Remember synckey GUID and ID
+        $guid = $matches[1];
+        $n = $matches[2];
+
+        // Cleanup all older syncstates
+        $dir = opendir(BASE_PATH . STATE_DIR);
+        if(!$dir)
+            return false;
+
+        while($entry = readdir($dir)) {
+            if(preg_match('/^s{0,1}\{([0-9A-Za-z-]+)\}([0-9]+)$/', $entry, $matches)) {
+                if($matches[1] == $guid && $matches[2] < $n) {
+                    unlink(BASE_PATH . STATE_DIR . "/$entry");
+                }
+            }
+        }
+
+        // Read current sync state
+        $filename = BASE_PATH . STATE_DIR . "/$synckey";
+
+        if(file_exists($filename))
+            return file_get_contents(BASE_PATH . STATE_DIR . "/$synckey");
+        else return false;
+    }
+
+    // Gets the new sync key for a specified sync key. You must save the new sync state
+    // under this sync key when done sync'ing (by calling setSyncState);
+    function getNewSyncKey($synckey) {
+        if(!isset($synckey) || $synckey == "0") {
+            return "{" . $this->uuid() . "}" . "1";
+        } else {
+            if(preg_match('/^s{0,1}\{([a-fA-F0-9-]+)\}([0-9]+)$/', $synckey, $matches)) {
+                $n = $matches[2];
+                $n++;
+                return "{" . $matches[1] . "}" . $n;
+            } else return false;
+        }
+    }
+
+    // Writes the sync state to a new synckey
+    function setSyncState($synckey, $syncstate) {
+        // Check if synckey is allowed
+        if(!preg_match('/^s{0,1}\{[0-9A-Za-z-]+\}[0-9]+$/', $synckey)) {
+            return false;
+        }
+
+        return file_put_contents(BASE_PATH . STATE_DIR . "/$synckey", $syncstate);
+    }
+
+    function uuid()
+    {
+        return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
+                    mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),
+                    mt_rand( 0, 0x0fff ) | 0x4000,
+                    mt_rand( 0, 0x3fff ) | 0x8000,
+                    mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ) );
+    }
+};
+
+?>
Index: /contrib/z-push/index.php
===================================================================
--- /contrib/z-push/index.php	(revision 4898)
+++ /contrib/z-push/index.php	(revision 4898)
@@ -0,0 +1,224 @@
+<?php
+/***********************************************
+* File      :   index.php
+* Project   :   Z-Push
+* Descr     :   This is the entry point
+*               through which all requests
+*               are called.
+*
+* Created   :   01.10.2007
+*
+*  Zarafa Deutschland GmbH, www.zarafaserver.de
+* This file is distributed under GPL v2.
+* Consult LICENSE file for details
+************************************************/
+
+ob_start(false, 1048576);
+
+include_once('zpushdefs.php');
+include_once("config.php");
+include_once("proto.php");
+include_once("request.php");
+include_once("debug.php");
+include_once("compat.php");
+include_once("version.php");
+
+// Attempt to set maximum execution time
+ini_set('max_execution_time', SCRIPT_TIMEOUT);
+set_time_limit(SCRIPT_TIMEOUT);
+
+debugLog("Start");
+debugLog("Z-Push version: $zpush_version");
+debugLog("Client IP: ". $_SERVER['REMOTE_ADDR']);
+
+$input = fopen("php://input", "r");
+$output = fopen("php://output", "w+");
+
+// The script must always be called with authorisation info
+if(!isset($_SERVER['PHP_AUTH_PW'])) {
+    header("WWW-Authenticate: Basic realm=\"ZPush\"");
+    header("HTTP/1.1 401 Unauthorized");
+    print("Access denied. Please send authorisation information");
+    debugLog("Access denied: no password sent.");
+	debugLog("end");
+	debugLog("--------");
+    return;
+}
+
+// split username & domain if received as one
+$pos = strrpos($_SERVER['PHP_AUTH_USER'], '\\');
+if($pos === false){
+    $auth_user = $_SERVER['PHP_AUTH_USER'];
+    $auth_domain = '';
+}else{
+    $auth_domain = substr($_SERVER['PHP_AUTH_USER'],0,$pos);
+    $auth_user = substr($_SERVER['PHP_AUTH_USER'],$pos+1);
+}
+$auth_pw = $_SERVER['PHP_AUTH_PW'];
+
+$cmd = $user = $devid = $devtype = "";
+
+// Parse the standard GET parameters
+if(isset($_GET["Cmd"]))
+    $cmd = $_GET["Cmd"];
+if(isset($_GET["User"]))
+    $user = $_GET["User"];
+if(isset($_GET["DeviceId"]))
+    $devid = $_GET["DeviceId"];
+if(isset($_GET["DeviceType"]))
+    $devtype = $_GET["DeviceType"];
+
+// The GET parameters are required
+if($_SERVER["REQUEST_METHOD"] == "POST") {
+    if(!isset($user) || !isset($devid) || !isset($devtype)) {
+        print("Your device requested the Z-Push URL without the required GET parameters");
+        return;
+    }
+}
+
+// Get the request headers so we can see the versions
+$requestheaders = apache_request_headers();
+if (isset($requestheaders["Ms-Asprotocolversion"])) $requestheaders["MS-ASProtocolVersion"] = $requestheaders["Ms-Asprotocolversion"];
+if(isset($requestheaders["MS-ASProtocolVersion"])) {
+    global $protocolversion;
+
+    $protocolversion = $requestheaders["MS-ASProtocolVersion"];
+    debugLog("Client supports version " . $protocolversion);
+} else {
+    global $protocolversion;
+
+    $protocolversion = "1.0";
+}
+
+if (isset($requestheaders["X-Ms-Policykey"])) $requestheaders["X-MS-PolicyKey"] = $requestheaders["X-Ms-Policykey"];
+if (isset($requestheaders["X-MS-PolicyKey"])) {
+    global $policykey;
+    $policykey = $requestheaders["X-MS-PolicyKey"];
+
+} else {
+    global $policykey;
+    $policykey = 0;
+}
+
+//get user agent
+if (isset($requestheaders["User-Agent"])) {
+    global $useragent;
+    $useragent = $requestheaders["User-Agent"];
+} else {
+    global $useragent;
+    $useragent = "unknown";
+}
+
+// Load our backend driver
+$backend_dir = opendir(BASE_PATH . "/backend");
+while($entry = readdir($backend_dir)) {
+    if(substr($entry,0,1) == "." || substr($entry,-3) != "php")
+        continue;
+
+    if (!function_exists("mapi_logon") && ($entry == "ics.php"))
+        continue;
+
+    include_once(BASE_PATH . "/backend/" . $entry);
+}
+
+// Initialize our backend
+$backend = new $BACKEND_PROVIDER();
+
+if($backend->Logon($auth_user, $auth_domain, $auth_pw) == false) {
+    header("HTTP/1.1 401 Unauthorized");
+    header("WWW-Authenticate: Basic realm=\"ZPush\"");
+    print("Access denied. Username or password incorrect.");
+    debugLog("Access denied: backend logon failed.");
+    debugLog("end");
+    debugLog("--------");
+    return;
+}
+
+// $user is usually the same as the PHP_AUTH_USER. This allows you to sync the 'john' account if you
+// have sufficient privileges as user 'joe'.
+if($backend->Setup($user, $devid, $protocolversion) == false) {
+    header("HTTP/1.1 401 Unauthorized");
+    header("WWW-Authenticate: Basic realm=\"ZPush\"");
+    print("Access denied or user '$user' unknown.");
+    debugLog("Access denied: backend setup failed.");
+    debugLog("end");
+    debugLog("--------");
+    return;
+}
+
+// check policy header 
+if (PROVISIONING === true && $_SERVER["REQUEST_METHOD"] != 'OPTIONS' && $cmd != 'Ping' && $cmd != 'Provision' && 
+    $backend->CheckPolicy($policykey, $devid) != SYNC_PROVISION_STATUS_SUCCESS &&
+    (LOOSE_PROVISIONING === false ||
+    (LOOSE_PROVISIONING === true && isset($requestheaders["X-MS-PolicyKey"])))) {    	
+    	
+    header("HTTP/1.1 449 Retry after sending a PROVISION command");
+    header("MS-Server-ActiveSync: 6.5.7638.1");
+    header("MS-ASProtocolVersions: 1.0,2.0,2.1,2.5");
+    header("MS-ASProtocolCommands: Sync,SendMail,SmartForward,SmartReply,GetAttachment,GetHierarchy,CreateCollection,DeleteCollection,MoveCollection,FolderSync,FolderCreate,FolderDelete,FolderUpdate,MoveItems,GetItemEstimate,MeetingResponse,Provision,ResolveRecipients,ValidateCert,Search,Ping");
+    header("Cache-Control: private");
+    debugLog("POST cmd $cmd denied: Retry after sending a PROVISION command");
+    debugLog("end");
+    debugLog("--------");
+    return;
+}
+
+// Do the actual request
+switch($_SERVER["REQUEST_METHOD"]) {
+    case 'OPTIONS':
+        header("MS-Server-ActiveSync: 6.5.7638.1");
+        header("MS-ASProtocolVersions: 1.0,2.0,2.1,2.5");
+        header("MS-ASProtocolCommands: Sync,SendMail,SmartForward,SmartReply,GetAttachment,GetHierarchy,CreateCollection,DeleteCollection,MoveCollection,FolderSync,FolderCreate,FolderDelete,FolderUpdate,MoveItems,GetItemEstimate,MeetingResponse,ResolveRecipients,ValidateCert,Provision,Search,Ping");
+        debugLog("Options request");
+        break;
+    case 'POST':
+        header("MS-Server-ActiveSync: 6.5.7638.1");
+        debugLog("POST cmd: $cmd");
+        // Do the actual request
+        if(!HandleRequest($backend, $cmd, $devid, $protocolversion)) {
+            // Request failed. Try to output some kind of error information. We can only do this if
+            // output had not started yet. If it has started already, we can't show the user the error, and
+            // the device will give its own (useless) error message.
+            if(!headers_sent()) {
+                header("Content-type: text/html");
+                print("<BODY>\n");
+                print("<h3>Error</h3><p>\n");
+                print("There was a problem processing the <i>$cmd</i> command from your PDA.\n");
+                print("<p>Here is the debug output:<p><pre>\n");
+                print(getDebugInfo());
+                print("</pre>\n");
+                print("</BODY>\n");
+            }
+        }
+        break;
+    case 'GET':
+        header("Content-type: text/html");
+        print("<BODY>\n");
+        print("<h3>GET not supported</h3><p>\n");
+        print("This is the z-push location and can only be accessed by Microsoft ActiveSync-capable devices.");
+        print("</BODY>\n");
+        break;
+}
+
+
+$len = ob_get_length();
+$data = ob_get_contents();
+
+ob_end_clean();
+
+// Unfortunately, even though zpush can stream the data to the client
+// with a chunked encoding, using chunked encoding also breaks the progress bar
+// on the PDA. So we de-chunk here and just output a content-length header and
+// send it as a 'normal' packet. If the output packet exceeds 1MB (see ob_start)
+// then it will be sent as a chunked packet anyway because PHP will have to flush
+// the buffer.
+
+header("Content-Length: $len");
+print $data;
+
+// destruct backend after all data is on the stream
+$backend->Logoff();
+
+debugLog("end");
+debugLog("--------");
+?>
